unit Editor_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DropFile, ExtCtrls, RVStyle, RVScroll, RichView,
  RVEdit, ComCtrls, RVItem;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    DFE: TDropFileEdit;
    Panel2: TPanel;
    SB: TStatusBar;
    RVE: TRichViewEdit;
    RVS: TRVStyle;
    Button1: TButton;
    B_FVA: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure DFEDropFile(Sender: TObject; FileName: String;
      DropPoint: TPoint);
    procedure DFEChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure B_FVAClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RVECurParaStyleChanged(Sender: TObject);
    procedure RVECurTextStyleChanged(Sender: TObject);
    procedure RVECaretMove(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure RVEKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button4Click(Sender: TObject);
  private
    FVA: boolean; // Formatvorlagenanzeige
    procedure UpdateParaFormatAnzeige;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.DFEDropFile(Sender: TObject; FileName: String;
  DropPoint: TPoint);
begin
   DFE.Text := FileName;
end;

procedure TForm1.DFEChange(Sender: TObject);
begin
   { TODO : Offene datei speichern }
   RVE.Clear;
   if AnsiLowerCase(ExtractFileExt(DFE.Text)) = '.rtf' then
   begin
      RVE.LoadRTF(DFE.Text);
   end
   Else if AnsiLowerCase(ExtractFileExt(DFE.Text)) = '.doc' then
   begin
      RVE.LoadRTF(DFE.Text);
   end
   else if AnsiLowerCase(ExtractFileExt(DFE.Text)) = '.rvf' then
   begin
      RVE.LoadRVF(DFE.Text);
   end;
   RVE.Format;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   RVE.SetFocus;
   DFE.Text := '.\1111-1-2_02.b.rtf';
end;

procedure TForm1.B_FVAClick(Sender: TObject);
var
   I,J: Integer;
   einzug: Integer;
begin
   try
      RVE.SetFocus;
   except
   end;
   einzug := 60;  // Wert um den eingezogen werden soll;

   if FVA = False then
   begin
      FVA := True;
      RVE.LeftMargin := einzug;
   end
   Else
   begin
      FVA := False;
      RVE.LeftMargin := 5;
   end;
   { TODO : Format ohne Positionsverlust }
   RVE.RVData.Format_(True, True, False, 0, RVE.Canvas,False, False);
   RVE.Invalidate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   FVA := False;
end;

procedure TForm1.RVECurParaStyleChanged(Sender: TObject);
begin
   UpdateParaFormatAnzeige;
end;

procedure TForm1.RVECurTextStyleChanged(Sender: TObject);
begin
   UpdateParaFormatAnzeige;
end;

procedure TForm1.UpdateParaFormatAnzeige;
begin
   try
      sb.Panels[1].Text := RVS.ParaStyles[RVE.CurParaStyleNo].StyleName + ' - ' + InttoStr(RVE.CurParaStyleNo);
   except

   end;
end;

procedure TForm1.RVECaretMove(Sender: TObject);
var
   i,r: Integer;
begin
   UpdateParaFormatAnzeige;
   i := RVE.CurTextStyleNo;
   try
      sb.Panels[0].Text := RVS.TextStyles[i].StyleName;
      Application.ProcessMessages;
      try
         r := RVE.GetItemTag(RVE.CurItemNo);
         sb.Panels[2].Text := InttoStr(r);
      except
         sb.Panels[2].Text := 'fehler';
      end;
   except
   end;
   if RVE.IsParaStart(RVE.CurItemNo) then
      SB.Panels[4].Text := 'Start'
   Else
       SB.Panels[4].Text := 'nicht Start';
   SB.Panels[5].Text := InttoStr(RVE.CurItemNo);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   RVS.SaveINI('c:\test.ini','Textpool');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   RVS.ParaStyles.Clear;
   RVS.TextStyles.Clear;
   RVS.LoadINI('c:\test.ini','Textpool');
end;

procedure TForm1.RVEKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if (ssAlt in Shift) or (ssCtrl in Shift)  then
   begin
      if ssCtrl in Shift then
      begin
   //      MessageDlg('Tastenkrzel: ' + InttoStr(Key), mtInformation, [mbOK], 0);
         SB.Panels[3].Text := InttoStr(Key);

         Case Key of
         38:   begin   // Pfeil rauf

               end;

         40:   begin   // Pfeil runter
                  Button4Click(self);
               end;
         end;
      end;
   end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
   ci: TCustomRVItemInfo;
   CurNo,i: Integer;
   StartNo, EndNo, StartNoNextPara: Integer;
   Offs, Offs2: Integer;
   uebnr: Integer;
   function StartOfNextPara(No:Integer):Integer;
   var
      I: Integer;
   begin
      Result:=No;
      Inc(No);
      if No<>rve.ItemCount then
         for I:=No to rve.ItemCount-1 do
         begin
           if rve.IsParaStart(I) then Break;
           Inc(Result);
         end;
      Inc(result);
   end;
begin
   RVE.SetFocus;
   CurNo:=rve.CurItemNo;
   StartNoNextPara:=StartOfNextPara(CurNo);
   offs := RVE.GetOffsBeforeItem(StartNoNextPara);
   RVE.SetSelectionBounds( StartNoNextPara, offs,
                           StartNoNextPara, offs);
end;

end.
