unit MyRVActions;

interface

uses Classes, Graphics, RichViewActions;

type
  TMyHFInfo = class(TComponent)
      FFont: TFont;
    public
      FAlignment: TAlignment;
      FText: String;
      FPrintOnFirstPage: Boolean;
      constructor Create(AOwner: TComponent); override;
      destructor  Destroy; override;
      procedure   MyAssignFrom(RVAHdrInfo: THFInfo);
      procedure   MyAssignTo(RVAHdrInfo: THFInfo);
    published
      property ReadFont: TFont read FFont write FFont;
      property Text: string read FText write FText;
      property Alignment: TAlignment read FAlignment write FAlignment;
      property PrintOnFirstPage: Boolean read FPrintOnFirstPage write FPrintOnFirstPage;
  end;


//function StringToComponent(Value: string): TComponent;
//function ComponentToString(Component: TComponent): string;

implementation
{
function ComponentToString(Component: TComponent): string;
var
  BinStream:TMemoryStream;
  StrStream: TStringStream;
  s: string;
begin
  BinStream := TMemoryStream.Create;
  try
    StrStream := TStringStream.Create(s);
    try
      BinStream.WriteComponent(Component);
      BinStream.Seek(0, soFromBeginning);
      ObjectBinaryToText(BinStream, StrStream);
      StrStream.Seek(0, soFromBeginning);
      Result:= StrStream.DataString;
    finally
      StrStream.Free;

    end;
  finally
    BinStream.Free
  end;
end;

function StringToComponent(Value: string): TComponent;
var
  StrStream:TStringStream;
  BinStream: TMemoryStream;
begin
  StrStream := TStringStream.Create(Value);
  try
    BinStream := TMemoryStream.Create;
    try
      ObjectTextToBinary(StrStream, BinStream);
      BinStream.Seek(0, soFromBeginning);
      Result := BinStream.ReadComponent(nil);

    finally
      BinStream.Free;
    end;
  finally
    StrStream.Free;
  end;
end;
}
constructor TMyHFInfo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FFont := TFont.Create;
  FFont.Name := 'Arial';
  FFont.Size := 10;
  FPrintOnFirstPage := True;
  FAlignment := taCenter;
end;

destructor TMyHFInfo.Destroy;
begin
  FFont.Free;
  inherited;
end;

procedure TMyHFInfo.MyAssignFrom(RVAHdrInfo: THFInfo);
begin
  FText := RVAHdrInfo.Text;
  FFont.Assign(RVAHdrInfo.Font);
  FPrintOnFirstPage := RVAHdrInfo.PrintOnFirstPage;
  FAlignment := RVAHdrInfo.Alignment;
end;

procedure TMyHFInfo.MyAssignTo(RVAHdrInfo: THFInfo);
begin
  RVAHdrInfo.Text := FText;
  RVAHdrInfo.Font.Assign(FFont);
  RVAHdrInfo.PrintOnFirstPage := FPrintOnFirstPage;
  RVAHdrInfo.Alignment := FAlignment;
end;

end.
