unit PreviewFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, RVScroll, CRVPP, RVPP, ExtCtrls, Buttons;

type
  TfrmPreview = class(TForm)
    Panel1: TPanel;
    rvpp: TRVPrintPreview;
    cmb: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Bevel1: TBevel;
    btnPrinterSetup: TSpeedButton;
    btnPrint: TSpeedButton;
    Bevel2: TBevel;
    Bevel3: TBevel;
    btnFitWidth: TSpeedButton;
    btnFullPage: TSpeedButton;
    Bevel4: TBevel;
    SpeedButton5: TSpeedButton;
    procedure cmbExit(Sender: TObject);
    procedure cmbKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure rvppZoomChanged(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure btnFitWidthClick(Sender: TObject);
    procedure btnFullPageClick(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateZoom;
  public
    { Public declarations }
  end;

var
  frmPreview: TfrmPreview;

implementation
uses unit1;
{$R *.DFM}

{-----------------------------------------------------------------------}
procedure TfrmPreview.cmbExit(Sender: TObject);
begin
    UpdateZoom;
end;

{-----------------------------------------------------------------------}
procedure TfrmPreview.cmbKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if Key=VK_RETURN then begin
      UpdateZoom;
      Key := 0;
    end;
end;

{-----------------------------------------------------------------------}
procedure TfrmPreview.UpdateZoom;
var s: String;
    zoom: Integer;
begin
    s := Trim(cmb.Text);
    if s=' ' then begin
      rvpp.ZoomMode := rvzmPageWidth;
      exit;
    end;
    if s='ü ' then begin
      rvpp.ZoomMode := rvzmFullPage;
      exit;
    end;
    if (s<>'') and (s[Length(s)]='%') then
      s := Copy(s,1,Length(s)-1);
    zoom := StrToIntDef(s,0);
    if (zoom<10) or (zoom>500) then
      Application.MessageBox('10-500%  ϴ.','Ȯ',MB_OK or MB_ICONSTOP)
    else
      rvpp.SetZoom(zoom);
end;
{-----------------------------------------------------------------------}
procedure TfrmPreview.rvppZoomChanged(Sender: TObject);
begin
    cmb.Text := IntToStr(rvpp.ZoomPercent)+'%';
end;

procedure TfrmPreview.SpeedButton1Click(Sender: TObject);
begin
    rvpp.First;
    Label1.Caption :=Format('%d / %d', [rvpp.PageNo, rvpp.RVPrint.PagesCount]);
end;

procedure TfrmPreview.SpeedButton2Click(Sender: TObject);
begin
    rvpp.Prev;
    Label1.Caption :=Format('%d / %d', [rvpp.PageNo, rvpp.RVPrint.PagesCount]);
end;

procedure TfrmPreview.SpeedButton3Click(Sender: TObject);
begin
    rvpp.Next;
    Label1.Caption :=Format('%d / %d', [rvpp.PageNo, rvpp.RVPrint.PagesCount]);
end;

procedure TfrmPreview.SpeedButton4Click(Sender: TObject);
begin
    rvpp.Last;
    Label1.Caption :=Format('%d / %d', [rvpp.PageNo, rvpp.RVPrint.PagesCount]);
end;

procedure TfrmPreview.btnPrintClick(Sender: TObject);
begin
    //form1.mnuFilePrintClick(sender);
end;

procedure TfrmPreview.btnFitWidthClick(Sender: TObject);
begin
    rvpp.ZoomMode := rvzmPageWidth;
end;

procedure TfrmPreview.btnFullPageClick(Sender: TObject);
begin
    rvpp.ZoomMode := rvzmFullPage;
end;

procedure TfrmPreview.SpeedButton5Click(Sender: TObject);
begin
    close;
end;

procedure TfrmPreview.FormActivate(Sender: TObject);
begin
    cmb.ItemIndex := 3;
    UpdateZoom;
    SpeedButton2Click(Self);
end;

end.
