{  This file is based on message of Peter Below (TeamB) in borland newsgroup }
unit StreamedGrid;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids;

type
  TStreamedGrid = class(TStringGrid)
  private
    { Private declarations }
    procedure CellsWriter(writer: TWriter);
    procedure CellsReader(reader: TReader);
  protected
    { Protected declarations }
    procedure DefineProperties(filer: TFiler);override;
  public
    { Public declarations }
  published
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('RichView', [TStreamedGrid]);
end;

{ TStreamedGrid }

procedure TStreamedGrid.CellsReader(reader: TReader);
var r, c: Integer;
begin
  reader.ReadListBegin;
  r := 0;
  while not reader.EndOfList do begin
    reader.readListBegin;
    c := 0;
    while not reader.EndOfList do begin
      Cells[c,r] := reader.ReadString;
      inc(c);
    end;
    reader.ReadListEnd;
    inc(r);
  end;
  reader.ReadListEnd;  
end;

procedure TStreamedGrid.CellsWriter(writer: TWriter);
var r, c: Integer;
begin
  writer.WriteListBegin;
  for r := 0 to RowCount-1 do begin
    writer.WriteListBegin;
    for c := 0 to ColCount-1 do
      writer.WriteString(Cells[c,r] );
    writer.WriteListEnd;
  end;
  writer.WriteListEnd;
End;


procedure TStreamedGrid.DefineProperties(filer: TFiler);
begin
  inherited;
  Filer.DefineProperty('Cells', CellsReader, CellsWriter,
                         (RowCount>0) and (ColCount>0));
end;

end.
